/// <reference types="node" />
import getRawBody from "raw-body";
import { ChildProcess } from "child_process";
import { Duplex } from "stream";
declare class Process extends Duplex implements Promise<void> {
    private readonly proc;
    private waiting;
    readonly then: <S = void, T = never>(resolve?: ((_: void) => S | PromiseLike<S>) | null, reject?: ((exitCode: number) => T | PromiseLike<T>) | null) => Promise<S | T>;
    readonly catch: <T = never>(reject?: ((exitCode: number) => T | PromiseLike<T>) | null) => Promise<void | T>;
    readonly finally: (cb?: (() => void) | null) => Promise<void>;
    constructor(proc: ChildProcess);
    _read(): void;
    _write(input: string, encoding: string, cb?: (error?: Error | null) => void): void;
    end(cb?: () => void): this;
    end(data: string | Uint8Array, cb?: () => void): this;
    end(str: string, encoding?: string, cb?: () => void): this;
    [Symbol.toStringTag]: string;
    toString(encoding?: getRawBody.Encoding): Promise<string>;
}
interface ModuleProxy {
    [name: string]: (...args: string[]) => Process;
}
declare const sh: ModuleProxy;
export = sh;
